\ compute rotation behaviour of galaxies               21may00py

\needs float     import float
\needs glconst | import glconst
\needs 3d-turtle include 3d-turtle.fs

float also glconst also opengl also

1 dfloats Constant dfloat

struct{
  dfloat x
  dfloat y
  dfloat z
  dfloat msum
  dfloat ax
  dfloat ay
  dfloat az
  dfloat ax+
  dfloat ay+
  dfloat az+
} element

: elements  sizeof element * ; macro

Variable stars

: star ( i -- )  elements stars @ cell+ + ; macro

1024 Value star#

: init-stars ( -- )  s" " stars $!
  star# 1+ elements stars $!len  stars $@ erase ;

: set-bulge ( n d1 d2 -- ) { f: d1 f: d2 }
  0 ?DO  BEGIN  frnd f2* !1 f-
                frnd f2* !1 f-
                frnd f2* !1 f-
                fover2 f**2 fover2 f**2 f+ fover f**2 f+
                !1 f> WHILE  fdrop fdrop fdrop  REPEAT
                I star
                d1 f* dup element x df!
                d1 f* dup element y df!
                d2 f*     element z df!  LOOP ;

: set-spiral ( n1 n2 di ds dz -- ) { f: di f: ds f: dz }
  swap ?DO  BEGIN  frnd
                   frnd fover fover !1 f+ 1/f f>  WHILE
                   fdrop fdrop  REPEAT ( fr ft ) rnd >r
                   fswap fover !1 f+ 1/f f*
                   r@ 1 and IF fnegate THEN
                   fswap di f+ ds f*
                   frnd f**2 !-5 f* fexp !3 f* fover f/ 
                   frnd !.5 f- f* fover f/
                   fover ds f/ di f- f**2 pi f2/ f* f+
                   frnd !.2 f* f+
                   r> 2 and IF pi f+ THEN
                   fsincos frot funder f* f-rot f*
                   I star dup element x df!
                          dup element y df!
                   dz f*      element z df!  LOOP ;

: DFVariable  Create 1 dfloats allot ;

DFVariable >x
DFVariable >y
DFVariable >z

: xyz@ ( n -- x y z )
  dup element x df@
  dup element y df@
      element z df@ ;
: >xyz ( n -- )
  dup element x df@ >x df!
  dup element y df@ >y df!
      element z df@ >z df! ;
\ : dxyz@ ( addr -- x y z )
\   dup element x df@ >x df@ f-
\   dup element y df@ >y df@ f-
\       element z df@ >z df@ f- ;
Code dxyz@ ( addr -- fx fy fz )
     .fl 0 element x AX D) fld  .fl >x #) fsub
     .fl 0 element y AX D) fld  .fl >y #) fsub
     .fl 0 element z AX D) fld  .fl >z #) fsub
     AX pop  next end-code macro
: a@ ( n -- x y z )
  dup element ax df@
  dup element ay df@
      element az df@ ;
\ : a+@ ( n -- x y z )
\   dup element ax df@ dup element ax+ df@ f+
\   dup element ay df@ dup element ay+ df@ f+
\   dup element ay df@     element az+ df@ f+ ;

Code a+@ ( n -- fx fy fz )
     .fl 0 element ax AX D) fld  .fl 0 element ax+ AX D) fadd
     .fl 0 element ay AX D) fld  .fl 0 element ay+ AX D) fadd
     .fl 0 element az AX D) fld  .fl 0 element az+ AX D) fadd
     AX pop  Next end-code macro

: vdup  fover2 fover2 fover2 ; macro
: vabs  f**2 fswap f**2 f+ fswap f**2 f+ ; macro
: vdup-abs  fover2 f**2 fover2 f**2 f+ fover f**2 f+ ; macro
Code vscale ( f1 f2 f3 fs -- f1' f2' f3' )
     1 <ST fmul  2 <ST fmul 3 STP fmul
     Next end-code macro
Code v+ ( v1 v2 -- )
     3 STP fadd  3 STP fadd  3 STP fadd  Next end-code macro

: set-msum ( -- )
  star# 0 ?DO  I star >xyz
      !0 star# 0 ?DO  I J <>
          IF   I star dxyz@ vabs 1/f f+  THEN
      LOOP   star# fm/ I star element msum df!
  LOOP ;

FVariable msum+
!0.5 msum+ f!

: set-a ( -- )
  star# 0 ?DO  I dup star >xyz
      !0 !0 !0
      star# 0 ?DO  dup I <>
          IF   I star dxyz@ vdup-abs
               fdup fsqrt f* 1/f vscale v+
          THEN
      LOOP drop
      I star !1 star# fm/ f>r
      fr@ f* dup element az df!
      fr@ f* dup element ay df!
      fr> f*     element ax df!
  LOOP ;

Variable dirsens  dirsens off

: set-a+ ( -- )
  star# 0 ?DO  I dup star >xyz
      !0 !0 !0
      dirsens @ IF
      star# 0 ?DO  dup I <>
                   IF  I star dup dxyz@
                       { f: dx f: dy f: dz | a+@
                         { f: ax f: ay f: az |
                           ax dx f* ay dy f* f+ az dz f* f+
                           dx f**2 dy f**2 f+ dz f**2 f+ f**2
                           f/ fnegate
                           fdup dx f* fswap
                           fdup dy f* fswap
                                dz f* } } v+
                   THEN
            LOOP drop
      ELSE  star# 0 ?DO  dup I <>
                         IF   I star dup dxyz@ vabs 1/f
                              f>r a+@ fr> vscale v+   THEN
            LOOP drop
      THEN  I star !1 star# fm/
      dup element msum df@ msum+ f@ f+ f/  f>r
      fr@ f* dup element az+ df!
      fr@ f* dup element ay+ df!
      fr> f*     element ax+ df!
  LOOP ;

: set-masses ( n -- )  init-stars
  star# swap &100 */ dup >r !1 !.3 set-bulge
  r> star# !.4 !2 !.2 set-spiral
  set-msum set-a ;

&50 set-masses

Variable vis-array

$80 Value vismax
: visminmax 0 max vismax 1- min ;
: vis* vismax 4/ fm* f>s visminmax ;

: fsqsum ( x y z -- d ) f**2 fswap f**2 f+ fswap f**2 f+ ;
: !vis-array  s" " vis-array $!
  vismax 2+ 2* cells vis-array $!len  vis-array $@ erase ;
: vis+ ( val i -- )
  star xyz@ fsqsum fsqrt vis* 1+ 2* cells
  vis-array $@ drop + >r 2 r@ +! dup 2* r@ cell+ +!
  r> 2 cells - >r  1 r@ +! dup r@ cell+ +!
  r> 4 cells + >r  1 r@ +!     r> cell+ +! ;
: draw-vis-array
  ^ canvas with  vismax dup steps 0 vismax home!
      rgb> drawcolor  path
      0 vismax 0 ?DO  I 2* 1+ cells vis-array $@ drop + 2@
                      swap dup IF  /  ELSE  nip  THEN
                      dup >r - negate
                      0 swap to  1 0 to r>  LOOP
      drop stroke
  endwith ;
: visualize-mass  !vis-array
  star# 0 ?DO  I star element msum df@
               !1 f* vis* I vis+  LOOP
  $00 $FF $00  draw-vis-array ;
: visualize-a  !vis-array
  star# 0 ?DO  I star a@ fsqsum fsqrt
               !.5 f* vis* I vis+  LOOP
  $00 $00 $FF   draw-vis-array ;
: visualize-a+  !vis-array
  star# 0 ?DO  I star a+@ fsqsum fsqrt
               !.5 f* vis* I vis+  LOOP
  $FF $00 $00  draw-vis-array ;

Create .white !&1  f>fs , !&1  f>fs , !&1  f>fs ,  !1  f>fs ,
Create .ambient 1 , 1 , 1 ,  1 ,
Create front_shininess  !&20.0 f>fs ,

: .color ( addr -- )
  GL_FRONT GL_AMBIENT_AND_DIFFUSE rot glMaterialfv ;

: galaxy-draw  ( o alx aly alz pitch bend roll -- )
  { alx aly alz alp alb alr |
    glcanvas with
        !0 !0 !0 !0 glClearColor
        !5 !60 w @ h @ 3d-turtle new  3d-turtle with

            GL_LIGHT_MODEL_AMBIENT .ambient glLightModeli
            GL_FRONT_AND_BACK GL_SHININESS front_shininess
                            glMaterialfv

            points smooth off

            0 !5 !5 !-10 get-xyz GL_POSITION 0 set-light

            !16 forward

            pi !180 f/
            fdup alx fm* x-left
            fdup aly fm* y-left
            fdup alz fm* z-left
            fdup alp fm* left
            fdup alb fm* up
                 alr fm* roll-left

            .white .color

            star# open-path next-round
            star# 0 ?DO
                I star dup element x df@
                       dup element y df@
                           element z df@ add-xyz
            LOOP next-round close-path
        dispose endwith
    endwith } ;
