\ RTL compiler for i386                                03apr99py
\ RAFTS means RISCs Are Faster Than Stack machines
\ in this case it's a CAFTS: CISCs Are Faster...

include mini-oof.fs

Vocabulary RTL   also memory also RTL definitions

object class
    cell var uses
    cell var reg
    cell var offset
    method init
    method asm
    method r/m@
    method reg@
end-class node

: build  new dup >r init r> ;

Variable uses-ax
Variable uses-cx
Variable uses-dx

: use-reg ( o reg addr -- o / exit )
    dup @ 0= IF  >r swap r> 2dup ! reg ! rdrop  THEN ;

: allocate-reg ( o -- )
    $C0 uses-ax use-reg
    $C9 uses-cx use-reg
    $D2 uses-dx use-reg ;

:noname >r r@ reg @ 0= IF  r@ allocate-reg  THEN
    r> reg @ ;                                 node defines reg@

node class
end-class arg

Variable argn
Variable argoff
Variable argadd

:noname >r r@ argn @ swap r@ offset ! cell r> argn +! ;
                                                arg defines init
:noname >r r@ reg @ ?dup IF  rdrop  EXIT  THEN
    r> offset @ ?dup IF argoff @ + $46  EXIT  THEN
    $06 ;                                       arg defines r/m@

node class
    cell var imm#
end-class lit

:noname imm# ! ;                               lit defines init

node class
    cell var uup
end-class unop

:noname uup ! ;                                unop defines init

node class
    cell var bleft
    cell var bright
end-class binop

:noname tuck bright ! bleft ! cell argadd +! ;
                                              binop defines init

binop class
    cell var opcode
end-class modrm

: ci,   dup c, 7 and 4 = IF  c,  THEN ;
: s/i,  ci, ;
: sreg, ci, c, ;
: lreg, ci, , ;

Table: r/m,  ireg,  lreg,  sreg,  noop  [

:noname >r
     r@ bleft @ r/m@ $C7 and r@ bright @ reg@ $38 and or
     r> opcode @ c, dup 6 >> cells r/m, + perform ;
                                               modrm defines asm

modrm class
end-class mod0F

:noname >r
     r@ bleft @ r/m@ $C7 and r@ bright @ reg@ $38 and or
     r> $0F c, opcode @ c, dup 6 >> cells r/m, + perform ;
                                               mod0F defines asm

unop class
    cell var immu#
    cell var opcode
    cell var minor
end-class immop

:noname >r
    r@ uup @ r/m@ $C7 and r@ minor @ $38 and or
    r> immu# @ opcode @ over -$80 $80 within
    IF  2+ c, c, c,  ELSE  c, c, ,  THEN ;
                                              immop defines asm
:noname  opcode ! minor ! immu# ! uup ! ;     immop defines init

node class
    cell var tleft
    cell var tmid
    cell var tright
end-class ternop

:noname tuck tright ! tuck tmid ! tleft ! 2 cells argadd +! ;
                                             ternop defines init


					     
: new-alu ( left right opcode xt -- o )
    >r >r
    over @ lit = over @ lit = and IF
	rdrop imm# @ swap imm# @ swap r> execute
	lit build  EXIT  THEN
    over @ lit = IF  swap  THEN
    dup @ lit = IF  imm# @ r> $81 immop build rdrop EXIT  THEN
    
2Variable rtlarray

: new-rtl ( par.. class -- o )
  rtlarray @ 0= IF  $10000 rtlarray Handle!
                    rtlarray cell+ off  THEN
  rtlarray 2@ + over @ dup rtlarray cell+ +!
  over swap erase swap over ! dup >r init r> ;

: ?arg ( 0 / o -- 0 o / o )
  dup 0= IF  arg new-rtl  THEN ;

: AX ( -- o )  arg new-rtl $C0 over reg ! ;

previous previous definitions
